---
title: 'MediaStreamTrack: ended event'
slug: Web/API/MediaStreamTrack/ended_event
tags:
  - Audio
  - Event
  - HTML DOM
  - HTMLMediaElement
  - Media
  - Media Streams API
  - Reference
  - Video
  - Web Audio API
  - ended
---
<div>{{DefaultAPISidebar("Media Capture and Streams")}}</div>

<p>The <strong><code>ended</code></strong> event of the {{domxref("MediaStreamTrack")}} interface is fired when playback or streaming has stopped because the end of the media was reached or because no further data is available.</p>

<table class="properties">
 <tbody>
  <tr>
   <th scope="row">Bubbles</th>
   <td>No</td>
  </tr>
  <tr>
   <th scope="row">Cancelable</th>
   <td>No</td>
  </tr>
  <tr>
   <th scope="row">Interface</th>
   <td>{{domxref("Event")}}</td>
  </tr>
  <tr>
   <th scope="row">Event handler property</th>
   <td>{{domxref("MediaStreamTrack.onended")}}</td>
  </tr>
 </tbody>
</table>

<h2 id="Usage_notes">Usage notes</h2>

<p><code>ended</code> events fire when the media stream track's source permanently stops sending data on the stream. There are various ways this can happen, including:</p>

<ul>
 <li>There is no more data left to send.</li>
 <li>The user revoked the permissions needed for the data to be sent.</li>
 <li>The hardware generating the source data has been removed or ejected.</li>
 <li>A remote peer has permanently stopped sending data; pausing media <em>does not</em> generate an <code>ended</code> event.</li>
</ul>

<h2 id="Examples">Examples</h2>

<p>This example sets up an event handler for the <code>ended</code> event, which changes an on-screen icon to indicate that the track is no longer active.</p>

<pre class="brush: js">track.addEventListener('ended', () =&gt; {
  let statusElem = document.getElementById("status-icon");
  statusElem.src = "/images/stopped-icon.png";
})</pre>

<p>You can also set up the event handler using the {{domxref("MediaStreamTrack.onended")}} property:</p>

<pre class="brush: js">track.onended = function() {
  let statusElem = document.getElementById("status-icon");

  statusElem.src = "/images/stopped-icon.png";
}</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table" style="height: 49px; width: 1000px;">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{ SpecName('Media Capture', '#event-mediastreamtrack-ended', 'ended') }}</td>
   <td>{{ Spec2('Media Capture') }}</td>
   <td>Initial specification.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.MediaStreamTrack.ended_event")}}</p>

<h2 id="See_Also">See Also</h2>

<ul>
 <li>{{domxref("HTMLMediaElement.playing_event", 'HTMLMediaElement: playing event')}}</li>
 <li>{{domxref("HTMLMediaElement.waiting_event", 'HTMLMediaElement: waiting event')}}</li>
 <li>{{domxref("HTMLMediaElement.seeking_event", 'HTMLMediaElement: seeking event')}}</li>
 <li>{{HTMLElement("audio")}}</li>
 <li>{{HTMLElement("video")}}</li>
 <li>{{domxref("HTMLMediaElement.ended_event", 'HTMLMediaElement: ended event')}}</li>
 <li>{{domxref("AudioScheduledSourceNode.ended_event", 'AudioScheduledSourceNode: ended event')}}</li>
</ul>
